/*
 * This Source Code is subject to the terms of the Mozilla Public License
 * version 2.0 (the "License"). You can obtain a copy of the License at
 * http://mozilla.org/MPL/2.0/.
 *
 * The Original Code is Forward Extension.
 * The Initial Developer of the Original Code is Onno Ekker.
 * Portions created by Onno Ekker <o.e.ekker@gmail.com> are Copyright
 * (c) 2008. All Rights Reserved.
 */

var myForwardCustomFilters = {
  initialized: false,

  // Initialize

  initialize: function(event)
  {
    if (myForwardCustomFilters.initialized)
      return;

    var strbundle = document.getElementById("bundle_forwardFilter");

    // Custom Filters

    var forwardInline = {
      id: "forwardCustomFilters.forwardInline",
      name: strbundle.getString("forwardInline.name"),
      isValidForType: function(type, scope) {return scope !== Components.interfaces.nsMsgSearchScope.newsFilter;},
      validateActionValue: function(actionValue, actionFolder, filterType)
      {
        if (actionValue.length < 3 || actionValue.indexOf("@") < 1)
        {
          var gFilterBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].
                                         getService(Components.interfaces.nsIStringBundleService).
                                         createBundle("chrome://messenger/locale/filter.properties");
          return gFilterBundle.GetStringFromName("enterValidEmailAddress");
        }
        return null;
      },
      allowDuplicates: true,
      apply: function(msgHdrs, actionValue, copyListener, filterType, msgWindow)
      {
        for (var index = 0; index < msgHdrs.length; index++)
        {
          var msgHdr = msgHdrs.queryElementAt(index, Components.interfaces.nsIMsgDBHdr);
          var compService = Components.classes["@mozilla.org/messengercompose;1"].
                                       getService(Components.interfaces.nsIMsgComposeService);
          compService.forwardMessage(actionValue, msgHdr, null, msgHdr.folder.server,
                                     Components.interfaces.nsIMsgComposeService.kForwardInline);
        }
      },
      isAsync: false,
      needsBody: true
    };

    var forwardAsAttachment = {
      id: "forwardCustomFilters.forwardAsAttachment",
      name: strbundle.getString("forwardAsAttachment.name"),
      isValidForType: function(type, scope) {return scope !== Components.interfaces.nsMsgSearchScope.newsFilter;},
      validateActionValue: function(actionValue, actionFolder, filterType)
      {
        if (actionValue.length < 3 || actionValue.indexOf("@") < 1)
        {
          var gFilterBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].
                                         getService(Components.interfaces.nsIStringBundleService).
                                         createBundle("chrome://messenger/locale/filter.properties");
          return gFilterBundle.GetStringFromName("enterValidEmailAddress");
        }
        return null;
      },
      allowDuplicates: true,
      apply: function(msgHdrs, actionValue, copyListener, filterType, msgWindow)
      {
        for (var index = 0; index < msgHdrs.length; index++)
        {
          var msgHdr = msgHdrs.queryElementAt(index, Components.interfaces.nsIMsgDBHdr);
          var compService = Components.classes["@mozilla.org/messengercompose;1"].
                                       getService(Components.interfaces.nsIMsgComposeService);
          compService.forwardMessage(actionValue, msgHdr, null, msgHdr.folder.server,
                                     Components.interfaces.nsIMsgComposeService.kForwardAsAttachment);
        }
      },
      isAsync: false,
      needsBody: true
    };

    var filterService = Components.classes["@mozilla.org/messenger/services/filters;1"].
                                   getService(Components.interfaces.nsIMsgFilterService);
    filterService.addCustomAction(forwardInline);
    filterService.addCustomAction(forwardAsAttachment);

    myForwardCustomFilters.initialized = true;
  }
};

window.addEventListener("load", myForwardCustomFilters.initialize, false);
